<?php

class Controller {

	public function __construct() {
/**
* Примерная карта расширений:
* .htm - "статика" из таблицы texts (например, страница "О компании"), абстрактная Сущность "Страница" или "Текст"
* .com - действия с данными на сервере (как правило, своего отображения нет, только ошибки, а если ошибок нет, перенаправление на referer), работает только с POST (и GET - для аякса?) запросами
* .aspx - статья с комментариями (? - комментарии могут быть и у .htm)
* .asp - комментарии отдельно
* .html - для "сущностей" из разных таблиц (например, товаров), хотя пока неясно, зачем
* .phtml - например, для администрирования
*/
		global $def;
		$this->set_request();
		$meta = $def['meta'];
		if (!isset($meta[$def['request']['subj']])) exit(def_404());
		
		if ($def['request']['ext'] == 'com') {
			$action = esse($def['meta'], $def['request']['subj'], 'action');
			$def['subj'] = esse($_POST, 'subj');
			if ($def['subj'] && $action) View::$action($def['subj']);
			else exit(def_404('!POST[com-action]'));
		}
		else {
			$def['subj'] = $def['request']['subj'];
			$view = esse($meta[$def['subj']], 'view');
			new View($def['subj'], $view);
		}
	}
	
	private function set_request() {
		
		global $def;
		$url = $def['env']['uri'];
		$url = preg_split("/\?/", $url);
		$url = $url[0]; //только файл, без папок!
		$url = explode('/', $url);
		$url = array_pop($url);
		if (!$url) $url = $def['default_url'];
		
		$subj = explode('.', $url);
		$ext = (count($subj) > 1) ? array_pop($subj) : '';
		$subj = implode('.', $subj);
		
		$key_source = array();
		$meta = esse($def['meta'], $subj);
		$flag = esse($meta, 'flag');
		if ($flag) $key_source[$flag] = $subj;
		$key_source += $_GET;
		$where = Config::get_key ($subj, $key_source);
		
		$def['request'] = array(
			'file' => $url,
			'subj' => $subj,
			'ext' => $ext,
			'where' => $where['where'],
			'full_key' => $where['full_key'],
		);
		
	}
	
}