<?php

class Data {
/** Данные должны возвращаться очень быстро. Убираем по максимуму все вычисления
*/
	private static $data; //потом как-то идентифицировать извлекаемые наборы данных и кэшировать
	
	public static function get($subj) {
		global $def;
		$meta = $def['meta'][$subj];
		$table = $meta['table'];
		$where = $def['request']['where'];
		$type = esse($meta, 'type');
		
		$method = self::get_method($type); 
		$data = self::$method($table, $where);
		
		$hash = var_export($data, true);
		
		$arr = array(
			'time' => time(), //не забудь!!!
			'hash' => crc32($hash),
			'data' => $data,
		);
		
		return $arr;
	}
	
	private static function get_method($type) {
		$valid_type = array('file', 'file_ini', 'Myslq');
		return 'get_' . (($type && in_array($type, $valid_type)) ? $type : 'Php');
	}
	
	public static function get_Php($table, $where = array()) {
		return Php::get($table, $where);
	}
	
	public static function get_Mysql($table, $where = array()) {
		global $def;
		$table = $def['mysql']['table_prefix'] . $table;

		return Mysql::get($table, $where);
	}
	
	public static function get_file_ini($f, $where = array()) {
		return (!empty($f) && file_exists($f)) ? parse_ini_file($f, true) : array();
	}
	
	public static function get_file($f, $where = array()) {
		//первая "строка", первая "ячейка"
		return (!empty($f) && file_exists($f)) ? array(array(implode(file($f)))) : array();
	}
	
	public static function write($subj) {
		global $def;
		
		if (!esse($def, 'user', 'status') && $def['env']['server_ip'] != $def['env']['klient_ip'])
			return 'not enough rights';
		
		$type = esse($def['meta'], $subj, 'type');
		$method = 'write_' . $type;
		self::check_gpc($_POST);
		return (!isset($_POST['set'])) 
			? '!POST[set]' 
			: self::$method($subj, $_POST['set']);
	}
	
	public static function write_file_ini($subj, &$arr) {
		global $def;
		$f = esse($def['meta'], $subj, 'table');
		$str = '';
		foreach ($arr as $sect => $props) {
			$str .= '[' . $sect . ']' . CR;
			foreach ($props as $key => $value) {
				$str .= $key . '="' . addcslashes($value, '"') . '"' . CR;
			}
		}
		file_put_contents($f, $str);
		return 0;
	}
	
	public static function check_gpc(&$arr) {
		if (!get_magic_quotes_gpc() && !get_magic_quotes_runtime()) return false;
		foreach($arr as $key => $value) {
			if (is_array($value)) check_gpc($arr[$key]);
			else $arr[$key] = stripslashes($value);
		}
	}

}
